//actual code starts at 278 (control+g)
//from ringslinger neo
local drawammobar = function(v, player, mo, cam)
	local maxammo = 20
	local curammo = player.powers[pw_underwater]/TICRATE
	local x = 160
	local y = 115
	local barx = x - maxammo/2
	local bary = y + 8
	local patch1 = v.cachePatch("SBARSEG1") //blue
	local patch3 = v.cachePatch("SBARSEG3") //black
	local patch5 = v.cachePatch("SBARSEG5") //red
	
		v.drawScaled((barx-6)*(FRACUNIT), (y+10)*(FRACUNIT)+(FRACUNIT/3), FRACUNIT/2, v.cachePatch("BUBLA0"), V_HUDTRANS|V_PERPLAYER,v.getColormap(nil, nil))
		--Ammo bar
		local pos = 0
		while (pos < maxammo)
			local patch = patch3
			pos = $ + 1
			
				if pos <= curammo
					if pos > curammo - 1
						if (curammo <= 1)
							//first
							if player.powers[pw_underwater] <= 11*TICRATE
							and leveltime % 4 == 0
								patch = patch5
							else
								patch = patch1
							end
						else
							//fill
							if player.powers[pw_underwater] <= 11*TICRATE
							and leveltime % 4 == 0
								patch = patch5
							else
								patch = patch1
							end
						end
					else
						//the one at the right end
						if player.powers[pw_underwater] <= 11*TICRATE
						and leveltime % 4 == 0
							patch = patch5
						else
							patch = patch1
						end
					end
				end
			v.draw(barx + pos - 1, bary, patch, V_HUDTRANS|V_PERPLAYER)
		end
		
end

local function DevmodeFlags(v, p)
//pflag stuff
v.drawString(100, 56, "Player Flags (In order listed on wiki)",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
if p.pflags & PF_FLIPCAM
	v.drawString(100, 60, "\x83"+"FC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(100, 60, "\x85"+"FC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_ANALOGMODE
	v.drawString(108+2, 60, "\x83"+"AM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(108+2, 60, "\x85"+"AM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_DIRECTIONCHAR
	v.drawString(116+4, 60, "\x83"+"DC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(116+4, 60, "\x85"+"DC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_AUTOBRAKE
	v.drawString(124+6, 60, "\x83"+"AB",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(124+6, 60, "\x85"+"AB",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_GODMODE
	v.drawString(132+8, 60, "\x83"+"GM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(132+8, 60, "\x85"+"GM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_NOCLIP
	v.drawString(140+10, 60, "\x83"+"NC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(140+10, 60, "\x85"+"NC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_INVIS
	v.drawString(148+12, 60, "\x83"+"IN",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(148+12, 60, "\x85"+"IN",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_ATTACKDOWN
	v.drawString(156+14, 60, "\x83"+"AD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(156+14, 60, "\x85"+"AD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SPINDOWN
	v.drawString(164+16, 60, "\x83"+"SD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(164+16, 60, "\x85"+"SD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPDOWN
	v.drawString(172+18, 60, "\x83"+"JD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(172+18, 60, "\x85"+"JD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_WPNDOWN
	v.drawString(180+20, 60, "\x83"+"WD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(180+20, 60, "\x85"+"WD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STASIS
	v.drawString(188+22, 60, "\x83"+"SS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(188+22, 60, "\x85"+"SS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPSTASIS
	v.drawString(196+26, 60, "\x83"+"JS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(196+26, 60, "\x85"+"JS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_FULLSTASIS
	v.drawString(204+28, 60, "\x83"+"FS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(204+28, 60, "\x85"+"FS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
//new  line
if p.pflags & PF_APPLYAUTOBRAKE
	v.drawString(100, 64, "\x83"+"AA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(100, 64, "\x85"+"AA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STARTJUMP
	v.drawString(108+2, 64, "\x83"+"SJ",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(108+2, 64, "\x85"+"SJ",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPED
	v.drawString(116+4, 64, "\x83"+"JU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(116+4, 64, "\x85"+"JU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_NOJUMPDAMAGE
	v.drawString(124+6, 64, "\x83"+"ND",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(124+6, 64, "\x85"+"ND",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SPINNING
	v.drawString(132+8, 64, "\x83"+"SP",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(132+8, 64, "\x85"+"SP",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STARTDASH
	v.drawString(140+10, 64, "\x83"+"ST",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(140+10, 64, "\x85"+"ST",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_THOKKED
	v.drawString(148+12, 64, "\x83"+"TH",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(148+12, 64, "\x85"+"TH",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SHIELDABILITY
	v.drawString(156+14, 64, "\x83"+"SA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(156+14, 64, "\x85"+"SA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_GLIDING
	v.drawString(164+16, 64, "\x83"+"GL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(164+16, 64, "\x85"+"GL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end

if p.soaptable
	local soap = p.soaptable
	//soap booleans
	v.drawString(100,68, "Soap Booleans (In order listed in init.lua)",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	if soap.isDash
		v.drawString(100, 72, "\x83"+"DA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(100, 72, "\x85"+"DA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.onGround
		v.drawString(108+2, 72, "\x83"+"OG",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(108+2, 72, "\x85"+"OG",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSoap
		v.drawString(116+4, 72, "\x83"+"IS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(116+4, 72, "\x85"+"IS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isValid
		v.drawString(124+6, 72, "\x83"+"VA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(124+6, 72, "\x85"+"VA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isIdle
		v.drawString(132+8, 72, "\x83"+"ID",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(132+8, 72, "\x85"+"ID",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isXmo
		v.drawString(140+10, 72, "\x83"+"XM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(140+10, 72, "\x85"+"XM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isXmoON
		v.drawString(148+12, 72, "\x83"+"XO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(148+12, 72, "\x85"+"XO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSuper
		v.drawString(156+14, 72, "\x83"+"SU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(156+14, 72, "\x85"+"SU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSuperM
		v.drawString(172+18, 72, "\x83"+"SM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(172+18, 72, "\x85"+"SM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isElevated
		v.drawString(180+20, 72, "\x83"+"EL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(180+20, 72, "\x85"+"EL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.inPain
		v.drawString(188+22, 72, "\x83"+"PA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(188+22, 72, "\x85"+"PA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.canADash
		v.drawString(196+24, 72, "\x83"+"CA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(196+24, 72, "\x85"+"CA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSValid
		v.drawString(204+26, 72, "\x83"+"SV",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(204+26, 72, "\x85"+"SV",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	//new line
	if soap.noShield
		v.drawString(100, 76, "\x83"+"NS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(100, 76, "\x85"+"NS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSol
		v.drawString(108+2, 76, "\x83"+"SO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(108+2, 76, "\x85"+"SO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isTransform
		v.drawString(116+4, 76, "\x83"+"TR",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(116+4, 76, "\x85"+"TR",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isWatered
		v.drawString(124+6, 76, "\x83"+"WA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(124+6, 76, "\x85"+"WA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isBoostm
		v.drawString(132+8, 76, "\x83"+"BM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(132+8, 76, "\x85"+"BM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isGod
		v.drawString(140+10, 76, "\x83"+"GO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(140+10, 76, "\x85"+"GO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
end
end
//sorry for this extremely long function!

//hud stuff for soap.devmode!!!!!!!!!!!!!!!!!!
//and maybe for some future stuff ;)
//local fttexty = 60
//local fttrans = 0
local shownNotif = false
local smflag = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER
local mach4f = 0
//with some from sms

//stupid hud thing v2
hud.add(function(v, p)
if not p.mo
return end
 
if not p.soaptable
return
end

if (p.powers[pw_carry] == CR_NIGHTSMODE)
return
end

//cant do anything without these locals first!
local soap = p.soaptable
local me = p.mo

if me.skin == "soapthehedge"	
	
	if (not me.health)
//	or (p.exiting)
		return
	end

//EW I HATE THIS THING!!!
///////FT START
	//i know this thing is annoying, but i want people to know how to play as this fella!
	if soap.firsttime
	//its our first time playing
	and not soap.firstttic
	//we're not waiting for the text to show anymore
//	and soap.fttic
	//we're allowed to show the text
//	and not (soap.ftblink % 2 == 0)
	and soap.ftblink
	and not (soap.ftkill and soap.ftblink % 2 == 0)
	and not (soap.ftblink-2*TICRATE < 30 and soap.ftblink % 2 == 0)
	and not (p == secondarydisplayplayer)
		
		v.drawString(soap.ftx, soap.fty, "New to\x88 Soap\x80? Check out\x86 soap_help\x80 to learn the ins and outs of\x88 Soap\x80.",V_ALLOWLOWERCASE|V_PERPLAYER|V_HUDTRANS, "thin-center")
		v.drawString(soap.ftx, (soap.fty+12), "\x86Use soap_help in console or press C2 to close",V_50TRANS|V_ALLOWLOWERCASE|V_PERPLAYER, "small-center")
	end

	if (soap.Scustom2OS)
	and not soap.firstttic
	and (not soap.ftkill)
		soap.ftkill = TICRATE
	end
///////FT END


//ok! lets copy that c2 thing
	//c2 indicator to show shield abilities are binded to c2
	if not soap.noShield
	and soap.isSValid
	//next to life
	//	v.drawScaled(((hudinfo[HUD_LIVES].x*5)*FRACUNIT), 175*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM,v.getColormap(nil, nil))
	//	v.drawString((hudinfo[HUD_LIVES].x*6)+2, hudinfo[HUD_LIVES].y+5, "Shield Ability",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small")
	//above life
		if not ((p.mrce) or (soap.isCloneF))
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, (hudinfo[HUD_LIVES].y-20)*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS,v.getColormap(nil, nil))
			if not ((RingSlinger) and (G_RingSlingerGametype()))
				v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-14, "Shield Ability ("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
			else
				//wrap for ringslinger neo
				v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-16, "Shield Ability \n("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
			end
		else //move up to account for mrce hud and for clonefighter
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, (hudinfo[HUD_LIVES].y-40)*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS,v.getColormap(nil, nil))
			v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-34, "Shield Ability ("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
		end
	end
//

//just look at your trail
/*
	if soap.airdashtimer
	and soap.airdashtimer <= 70
	and not soap.airdashed
		v.drawString(soap.ftx+135, soap.fty+60, 70-soap.airdashtimer+"/70",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small-center")
	end
*/

//ringslinger neo "viewmodel" covers this. too bad!
//add soap after ringslinger neo!
if soap.cosspeedometer
	if soap.cosspeedometer == 1
		v.drawString((hudinfo[HUD_LIVES].x*20)+9-7, hudinfo[HUD_LIVES].y-4, soap.accSpeed, smflag, "thin-right")		
//		v.drawString((hudinfo[HUD_LIVES].x*20)+14, hudinfo[HUD_LIVES].y-2, "/",smflag, "thin")
		v.drawString((hudinfo[HUD_LIVES].x*20)+20+6, hudinfo[HUD_LIVES].y+2, p.normalspeed, smflag|V_YELLOWMAP, "right")
	elseif soap.cosspeedometer == 2
		v.drawString((hudinfo[HUD_LIVES].x*20)+9-6, hudinfo[HUD_LIVES].y-4, soap.accSpeed/FRACUNIT, smflag, "thin-right")		
		v.drawString((hudinfo[HUD_LIVES].x*20)+14-6, hudinfo[HUD_LIVES].y-2, "/",smflag, "thin")
		v.drawString((hudinfo[HUD_LIVES].x*20)+20-6, hudinfo[HUD_LIVES].y, p.normalspeed/FRACUNIT, smflag|V_YELLOWMAP, "left")
	end
end

if p.powers[pw_underwater]
	drawammobar(v, p, me)
end


if p.dashmode >= 4*TICRATE
	v.drawString(160, 128, p.dashmode-(3*TICRATE), V_HUDTRANS|V_ALLOWLOWERCASE|V_PERPLAYER|mach4f, "small-center")
end

end //skin if

//show lag thing
if soap.isElevated
	if SoapIsLargeMap(23)
	and (not shownNotif)
			v.drawString(soap.ftx, soap.fty, "Experiecing lag?",V_ALLOWLOWERCASE|V_HUDTRANS, "thin-center")
			v.drawString(soap.ftx, soap.fty+12, " Try disabling MobjThinkers with "+"\x86"+"soap_mobjthinkers ring_pull "+"\x80"+"to ease the lag.",V_ALLOWLOWERCASE|V_HUDTRANS, "thin-center")
			v.drawString(soap.ftx, (soap.fty+24), "\x86Press Custom1 to dismiss this message.",V_30TRANS|V_ALLOWLOWERCASE, "small-center")
			if p.cmd.buttons & BT_CUSTOM1
			and (not shownNotif)
				shownNotif = true
			end
	elseif not SoapIsLargeMap(234)
		shownNotif = false
	end
end

//show how many YDs are chasing you!
if gametype == GT_YELLOWDEMON
or ((SoapFetchConstant("soap_yellowdemon")) and (me.skin == "soapthehedge"))
	v.drawScaled(((hudinfo[HUD_LIVES].x*5)*FRACUNIT)+(5*FRACUNIT), 189*FRACUNIT, FRACUNIT/2,v.getSpritePatch("RING", A, 0, 0), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER)
	v.drawString((hudinfo[HUD_LIVES].x*6)+2, hudinfo[HUD_LIVES].y+5, soap.YDcount,V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER, "thin")
end

if soap.devmode
	DevmodeFlags(v, p)
end

if soap.ptaicolor == 1
	mach4f = V_REDMAP
else
	mach4f = V_GREENMAP
end

end)
